// ***********************************
// MÉTODOS DE ANÁLISIS DE ESTABILIDAD
// ***********************************
clear
// Se carga la librería de funciones para el diagrama de Bode sintótico.
// L librería debe estar en el directorio de operació. 
pth=pwd()
pth=pth+"\T_d_Control_lib.sci"
exec(pth)

xdel(winsid());
clc

s=%s;
GH=syslin("c",1e7*(s+10),s*(s-1)*(s+100)^2*(s+1000));
zpk(GH)
// Método de Routh Hurwitz
routh_t(GH,poly(0,"k"))
kpure(GH)
// Diagramas de Bode
xdel(winsid())
wr=logspace(-2,5,500);
// Singularidades individuales
G1=syslin("c",-10,1);
[M1,F1,w1]=bode_asym(G1,wr,2,"blue");
subplot(211)
plot2d("ln",wr,M1,color("scilabgreen2"));
set_my_line_styles(1,2);
xgrid(color("gray"))
title("Diagrama de Bode de Módulo ")
ylabel("Ganancia [dB]")
subplot(212)
plot2d("ln",wr,F1,color("scilabgreen2"));
set_my_line_styles(1,2);
xgrid(color("gray"))
title("Diagrama de Bode de Fase")
ylabel("Fase [º]")
xlabel("Frecuencia [rad/seg]")
figure
G1=syslin("c",1,s);
[M1,F1,w1]=bode_asym(G1,wr,2,"magenta");
subplot(211)
plot2d("ln",wr,M1,color("magenta"));
set_my_line_styles(1,2);
xgrid(color("gray"))
title("Diagrama de Bode de Módulo ")
ylabel("Ganancia [dB]")
subplot(212)
plot2d("ln",wr,F1,color("magenta"));
set_my_line_styles(1,2);
xgrid(color("gray"))
title("Diagrama de Bode de Fase")
ylabel("Fase [º]")
xlabel("Frecuencia [rad/seg]")
figure
G1=syslin("c",1+s/10,1);
[M1,F1,w1]=bode_asym(G1,wr,2,"red");
subplot(211)
plot2d("ln",wr,M1,color("red"));
set_my_line_styles(1,2);
xgrid(color("gray"))
title("Diagrama de Bode de Módulo ")
ylabel("Ganancia [dB]")
subplot(212)
plot2d("ln",wr,F1,color("red"));
set_my_line_styles(1,2);
xgrid(color("gray"))
title("Diagrama de Bode de Fase")
ylabel("Fase [º]")
xlabel("Frecuencia [rad/seg]")
figure
G1=syslin("c",1,1-s);
[M1,F1,w1]=bode_asym(G1,wr,2,"blue");
subplot(211)
plot2d("ln",wr,M1,color("blue"));
set_my_line_styles(1,2);
xgrid(color("gray"))
title("Diagrama de Bode de Módulo ")
ylabel("Ganancia [dB]")
subplot(212)
plot2d("ln",wr,F1,color("blue"));
set_my_line_styles(1,2);
xgrid(color("gray"))
title("Diagrama de Bode de Fase")
ylabel("Fase [º]")
xlabel("Frecuencia [rad/seg]")
figure
G1=syslin("c",1,(1+s/100)^2);
[M1,F1,w1]=bode_asym(G1,wr,2,"brown");
subplot(211)
plot2d("ln",wr,M1,color("brown"));
set_my_line_styles(1,2);
xgrid(color("gray"))
title("Diagrama de Bode de Módulo ")
ylabel("Ganancia [dB]")
subplot(212)
plot2d("ln",wr,F1,color("brown"));
set_my_line_styles(1,2);
xgrid(color("gray"))
title("Diagrama de Bode de Fase")
ylabel("Fase [º]")
xlabel("Frecuencia [rad/seg]")
figure
G1=syslin("c",1,1+s/1000);
[M1,F1,w1]=bode_asym(G1,wr,2,"cyan");
subplot(211)
plot2d("ln",wr,M1,color("cyan"));
set_my_line_styles(1,2);
xgrid(color("gray"))
title("Diagrama de Bode de Módulo ")
ylabel("Ganancia [dB]")
subplot(212)
plot2d("ln",wr,F1,color("cyan"));
set_my_line_styles(1,2);
xgrid(color("gray"))
title("Diagrama de Bode de Fase")
ylabel("Fase [º]")
xlabel("Frecuencia [rad/seg]")
halt("presione enter para seguir")
// Bode asintótico
xdel(winsid());
[M1,F1,w1]=bode_asym(GH,wr,0,"red");
g_margin(GH)
F180=-180*ones(1,500);
subplot(211)
plot2d("ln",wr,M1,color("blue"));
set_my_line_styles(1,2);
xgrid(color("gray"))
title("Diagrama de Bode de Módulo ")
ylabel("Ganancia [dB]")
subplot(212)
plot2d("ln",wr,F1,color("blue"));
set_my_line_styles(1,2);
plot(wr,F180,"--r");
plot(wr,2*F180,"--r");
xgrid(color("gray"))
title("Diagrama de Bode de Fase")
ylabel("Fase [º]")
xlabel("Frecuencia [rad/seg]")

halt("presione enter para seguir");

// Nyquist Logarítmico
xdel(winsid());
TrayectoNyq(2);
K=0.5
figure("BackgroundColor",[1 1 1]);
LogNyquist(K*GH,6,2);
K=50
figure("BackgroundColor",[1 1 1]);
LogNyquist(K*GH,6,2);
K=200
figure("BackgroundColor",[1 1 1]);
LogNyquist(K*GH,6,2);

halt("presione enter para seguir");

// Bode exacto
close(winsid());
wr=logspace(-2,5,500);;    // Rango de frecuencias
fx=wr/2/%pi;
resp=repfreq(GH,fx);       // Respuesta en frecuencia
[DB,F]=dbphi(resp);
subplot(211)
plot2d("ln",wr,DB,color("blue"));
set_my_line_styles(1,2);
xgrid(color("gray"))
title("Diagrama de Bode de Módulo ")
ylabel("Ganancia [dB]")
subplot(212)
plot2d("ln",wr,F,color("red"));
set_my_line_styles(1,2);
xgrid(color("gray"))
title("Diagrama de Bode de Fase")
ylabel("Fase [º]")
xlabel("Frecuencia [rad/seg]")

// Método de Routh Hurwitz
routh_t(GH,poly(0,"k"))
kpure(GH)

